/****************************************************************************

                      (C) copyright Coding Technologies (2004)
                               All Rights Reserved

 This software module was developed by Coding Technologies (CT). This is
 company confidential information and the property of CT, and can not be
 reproduced or disclosed in any form without written authorization of CT.

 Those intending to use this software module for other purposes are advised
 that this infringe existing or pending patents. CT has no liability for
 use of this software module or derivatives thereof in any implementation.
 Copyright is not released for any means.  CT retains full right to use the
 code for its own purpose, assign or sell the code to a third party and to
 inhibit any user or third party from using the code. This copyright notice
 must be included in all copies or derivative works.

 $Id: aac_ram.c,v 1.1.2.6 2004/05/30 14:04:23 ehr Exp $

****************************************************************************/
/*!
  \file
  \brief  Memory layout  $Revision: 1.1.2.6 $
  \author Josef Hoepfl
*/
#include <stdio.h>
#include "aacdecoder.h"
#include "aac_ram.h"
#include "FloatFR.h"

/*
  Static memory areas, must not be overwritten in other sections of the decoder
*/

/* The structure CAacDecoderStaticChannelInfo contains the static sideinfo which is needed
   for the decoding of one aac channel. Dimension: #AacDecoderChannels */
CAacDecoderStaticChannelInfo AacDecoderStaticChannelInfo[Channels];

/* The structure CStreamInfo contains the streaming information. */
CStreamInfo StreamInfo;

/* Overlap buffer */
float OverlapBuffer[Channels*OverlapBufferSize];

CConcealmentInfo ConcealmentInfo[Channels];



/*!
  Dynamic memory areas, might be reused in other algorithm sections,
  e.g. the sbr decoder
*/

/* AAC Decoder Workbuffer */
float WorkBufferCore[Channels*MaximumBinsLong];
extern float TimeDataFloat[4*MaximumBinsLong]; /* allocated in main.c */

#ifdef LP_SBR_ONLY
CAacDecoderChannelInfo AacDecoderChannelInfo[Channels];

CAacDecoderChannelInfo *pAacDecoderChannelInfoInit[Channels] =
{
  &AacDecoderChannelInfo[0],
  &AacDecoderChannelInfo[1]
};
#else
extern float InterimResult[MaximumBinsLong];

CAacDecoderChannelInfo *pAacDecoderChannelInfoInit[Channels] =
{
  (CAacDecoderChannelInfo *) &InterimResult[0*sizeof(CAacDecoderChannelInfo)/sizeof(float)],
  (CAacDecoderChannelInfo *) &InterimResult[1*sizeof(CAacDecoderChannelInfo)/sizeof(float)]
};
#endif


CAacDecoderDynamicData *pAacDecoderDynamicDataInit[Channels] =
{
  (CAacDecoderDynamicData *) &TimeDataFloat[3*MaximumBinsLong],
  (CAacDecoderDynamicData *) &TimeDataFloat[3*MaximumBinsLong+sizeof(CAacDecoderDynamicData)/sizeof(float)]
};

CAacDecoderDynamicCommonData *pAacDecoderDynamicCommonDataInit =
  (CAacDecoderDynamicCommonData *) &TimeDataFloat[3*MaximumBinsLong+2*sizeof(CAacDecoderDynamicData)/sizeof(float)];

