/****************************************************************************

                      (C) copyright Coding Technologies (%YEAR%)
                               All Rights Reserved 

 This software module was developed by Coding Technologies (CT). This is
 company confidential information and the property of CT, and can not be
 reproduced or disclosed in any form without written authorization of CT.

 Those intending to use this software module for other purposes are advised
 that this infringe existing or pending patents. CT has no liability for
 use of this software module or derivatives thereof in any implementation.
 Copyright is not released for any means.  CT retains full right to use the
 code for its own purpose, assign or sell the code to a third party and to
 inhibit any user or third party from using the code. This copyright notice
 must be included in all copies or derivative works.

 $Id: fileifc.h,v 1.2.6.1 2003/10/28 19:28:22 snd Exp $

*******************************************************************************/


#ifndef __fileifc_h__
#define __fileifc_h__

#include <stdio.h>
#include <stdlib.h>

#include "MP4Movies.h"
#include "audioobjecttypes.h"

typedef struct FileWrapper
{
  ISOMovie theMovie ;

  MP4TrackReader theReader ;
  MP4Handle theSample ;

  AUDIO_OBJECT_TYPE audioObjectType;
  //  MPEG_4_PROFILE profileLevelIndication;

  unsigned int samplingRate;
  unsigned int extensionSamplingRate;
  unsigned int bitRate;
  unsigned int channelConfig;
  
  //  MPEG_2_PROFILE profile;
  unsigned int isMp4File;

  FILE *inputFile;

} FileWrapper, *FileWrapperPtr;

#ifdef __cplusplus
extern "C" {
#endif

FileWrapperPtr FileWrapper_Open(char fileName[]);
unsigned int FileWrapper_Read(FileWrapperPtr transport, unsigned char *buffer, unsigned int bufSize, unsigned int *len);
unsigned int FileWrapper_Close(FileWrapperPtr transport);

unsigned int FileWrapper_IsMp4File(FileWrapperPtr transport);

unsigned int FileWrapper_Is3GPPFile(FileWrapperPtr transport);

#ifdef __cplusplus
}
#endif

#endif
