/****************************************************************************

                      (C) copyright Coding Technologies (%YEAR%)
                               All Rights Reserved 

 This software module was developed by Coding Technologies (CT). This is
 company confidential information and the property of CT, and can not be
 reproduced or disclosed in any form without written authorization of CT.

 Those intending to use this software module for other purposes are advised
 that this infringe existing or pending patents. CT has no liability for
 use of this software module or derivatives thereof in any implementation.
 Copyright is not released for any means.  CT retains full right to use the
 code for its own purpose, assign or sell the code to a third party and to
 inhibit any user or third party from using the code. This copyright notice
 must be included in all copies or derivative works.

 $Id: simpleBitstream.h,v 1.1 2003/09/18 16:32:54 ehr Exp $

*******************************************************************************/

/*!
  \file
  \brief   simple bitstream handler
  \author  Stefan Gewinner 2003/02/16
*/

#if !defined (__simpleBitstream_H__)
#define __simpleBitstream_H__

typedef struct simpleBitstream
{
  const unsigned char *buffer ;

  unsigned int readBits ;

  unsigned int dataWord ;
  unsigned int validBits ;

} simpleBitstream, *simpleBitstreamPtr ;

static void __initializeBitstream (simpleBitstreamPtr self, const unsigned char *p)
{
  self->validBits = self->readBits = self->dataWord = 0 ;

  self->buffer = p ;
}

static int __getBits (simpleBitstreamPtr self, const unsigned int numberOfBits)
{
  if (self->validBits <= 16)
  {
    self->validBits += 16 ;
    self->dataWord <<= 16 ;

    self->dataWord |= (unsigned int) *self->buffer++ << 8 ;
    self->dataWord |= (unsigned int) *self->buffer++ ;
  }

  self->readBits += numberOfBits ;
  self->validBits -= numberOfBits ;

  return ((self->dataWord >> self->validBits) & ((1L << numberOfBits) - 1)) ;
}

static int __getReadBits(simpleBitstreamPtr self)
{
  return self->readBits;
}
#endif
