/****************************************************************************
 
                      (C) copyright Coding Technologies (2004)
                               All Rights Reserved
 
 This software module was developed by Coding Technologies (CT). This is
 company confidential information and the property of CT, and can not be
 reproduced or disclosed in any form without written authorization of CT.
 
 Those intending to use this software module for other purposes are advised
 that this infringe existing or pending patents. CT has no liability for
 use of this software module or derivatives thereof in any implementation.
 Copyright is not released for any means.  CT retains full right to use the
 code for its own purpose, assign or sell the code to a third party and to
 inhibit any user or third party from using the code. This copyright notice
 must be included in all copies or derivative works.
 
 $Id: psy_data.h,v 1.6.2.2 2004/02/16 21:05:58 ehr Exp $
 
****************************************************************************/
/*!
  \file 
  \brief  Psychoaccoustic data $Revision: 1.6.2.2 $
  \author M. Werner
*/
#ifndef _PSY_DATA_H
#define _PSY_DATA_H

#include "block_switch.h"
#include "tns.h"

/*
  the structs can be implemented as unions
*/

typedef struct{
  float Long[MAX_GROUPED_SFB];
  float Short[TRANS_FAC][MAX_SFB_SHORT];
}SFB_THRESHOLD;

typedef struct{
  float Long[MAX_GROUPED_SFB];
  float Short[TRANS_FAC][MAX_SFB_SHORT];
}SFB_ENERGY;

typedef struct{
  float Long;
  float Short[TRANS_FAC];
}SFB_ENERGY_SUM;

typedef struct{
  BLOCK_SWITCHING_CONTROL   blockSwitchingControl;          /* block switching */
  float                     *mdctDelayBuffer;               /* mdct delay buffer [BLOCK_SWITCHING_OFFSET]*/
  float                     sfbThresholdnm1[MAX_SFB];       /* PreEchoControl */

  SFB_THRESHOLD             sfbThreshold;                   /* adapt           */
  SFB_ENERGY                sfbEnergy;                      /* sfb Energy      */
  SFB_ENERGY                sfbEnergyMS;
  SFB_ENERGY_SUM            sfbEnergySum;
  SFB_ENERGY_SUM            sfbEnergySumMS;
  SFB_ENERGY                sfbSpreadedEnergy;

  float                     *mdctSpectrum;                  /* mdct spectrum [FRAME_LEN_LONG] */
}PSY_DATA;

#endif /* _PSY_DATA_H */
