/****************************************************************************

                      (C) copyright Coding Technologies (2004)
                               All Rights Reserved

 This software module was developed by Coding Technologies (CT). This is
 company confidential information and the property of CT, and can not be
 reproduced or disclosed in any form without written authorization of CT.

 Those intending to use this software module for other purposes are advised
 that this infringe existing or pending patents. CT has no liability for
 use of this software module or derivatives thereof in any implementation.
 Copyright is not released for any means.  CT retains full right to use the
 code for its own purpose, assign or sell the code to a third party and to
 inhibit any user or third party from using the code. This copyright notice
 must be included in all copies or derivative works.

 $Id: resampler.h,v 1.4.2.5 2004/05/30 13:59:10 ehr Exp $

*******************************************************************************/
#ifndef __RESAMPLER_H
#define __RESAMPLER_H
/*!
  \file
  \brief  Resampler Tool Box $Revision: 1.4.2.5 $
  \author M. Werner (SEED / Software Development Karlsruhe)
*/

#define BUFFER_SIZE 32  


typedef struct
{
  const float *coeffIIRa;
  const float *coeffIIRb;
  int noOffCoeffs;
  float ring_buf_1[BUFFER_SIZE];
  float ring_buf_2[BUFFER_SIZE];
  int ptr;
} IIR_FILTER;


typedef struct
{
  IIR_FILTER iirFilter;
  int ratio;
  int transitionFactor;
  int delay;
  int pending;
} IIR21_RESAMPLER;



int 
InitIIR21_Resampler(IIR21_RESAMPLER *ReSampler,
                    int transitionFactor,
                    int ratio);

int 
IIR21_Downsample(IIR21_RESAMPLER *DownSampler,
                 float *inSamples,
                 int numInSamples,
                 int inStride,
                 float *outSamples,
                 int *numOutSamples,
                 int outstride);

int 
IIR21_Upsample( IIR21_RESAMPLER  *UpSampler,
                float        *inSamples,
                int           numInSamples,
                int           inStride,
                float        *outSamples,
                int          *numOutSamples,
                int           outstride);
#endif


